﻿using Microsoft.Xaml.Behaviors;
using Syncfusion.UI.Xaml.Grid;
using System.Windows.Controls;
using System.Reflection;

namespace SfDataGridDemo
{
    public class SfDataGridBehavior : Behavior<SfDataGrid>
    {
        protected override void OnAttached()
        {
            base.OnAttached();           
            //Event subscription
            this.AssociatedObject.FilterItemsPopulating += OnFilterItemsPopulating;
        }

        //Event customization
        private void OnFilterItemsPopulating(object sender, GridFilterItemsPopulatingEventArgs e)
        {
            if (e.FilterControl != null)
            {
                //Here get the PART_OkButton  by using reflection in SfDataGrid
                var okButton = (Button)e.FilterControl.GetType().GetField("OkButton", BindingFlags.Instance | BindingFlags.NonPublic).GetValue(e.FilterControl);

                //Here get the SfDataGrid
                var sfDataGrid = sender as SfDataGrid;

                if(sfDataGrid != null && okButton != null && sfDataGrid.View != null && sfDataGrid.View.Records != null)
                {
                    //here check the condition based on your scenario
                    if(sfDataGrid.View.Records.Count == 0)
                    {
                        //Here disable the PART_OkButton of filtertogglebutton
                        okButton.IsEnabled = false;
                    }
                    else
                        //Here enable the PART_OkButton of filtertogglebutton
                        okButton.IsEnabled = true;
                }
            }
        }
      
        protected override void OnDetaching()
        {
            base.OnDetaching();
            this.AssociatedObject.FilterItemsPopulating -= OnFilterItemsPopulating;
        }
    }    
}